/*
 * Copyright 1991, 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */

#include <stdio.h>
#include <gl.h>
#include <device.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/types.h>
#include <sys/dir.h>
#include <libc.h>
#include <audio.h>
#include "aifflib.h"

#define RGBTIMEFACT 3.2
#define LMTIMEFACT 1.35
#define MMTIMEFACT 1.35
#define BUFCHUNKSIZE 512
#define FUDGE 15
#define MAXBUFFERSIZE 60000
#define ABUFFERSIZE 40000
float v0[3] = { -1.0, -1.0, -1.0 } ;
float v1[3] = { -1.0, -1.0,  1.0 } ;
float v2[3] = { -1.0,  1.0,  1.0 } ;
float v3[3] = { -1.0,  1.0, -1.0 } ;
float v4[3] = {  1.0, -1.0, -1.0 } ;
float v5[3] = {  1.0, -1.0,  1.0 } ;
float v6[3] = {  1.0,  1.0,  1.0 } ;
float v7[3] = {  1.0,  1.0, -1.0 } ;

#define ORDER 64
#define DURATION 25
#define MAXDURATION (DURATION<<1)
#define TWOPI  6.2832
float amp[MAXDURATION][ORDER];	   /* independent variable */
extern "C" {
 Colorindex rgbi( RGBvalue, RGBvalue, RGBvalue); 
};
float power[DURATION][ORDER][3];   /* vertices of rolling carpet */
float ident_matrix[4][4] = {
	{1.0, 0.0, 0.0, 0.0},
	{0.0, 1.0, 0.0, 0.0},
	{0.0, 0.0, 1.0, 0.0},
	{0.0, 0.0, 0.0, 1.0},
};

char	*myname;
ALport port, outport;
ALconfig conf;
int curlinewidth = 2;
int candoRGB = 0;
int mono = 0;
int DB = 1, framecount =0;
int cmapmode = 0;
 typedef short SAMPLE;

//SAMPLE *p;
SAMPLE tbuf[2*MAXBUFFERSIZE];

extern float spectrum( SAMPLE * , int , float *, int, float );
//SAMPLE * pisnd, *pend, *pstrt;

float dist=0.0, d_dist=0.0;
Angle azim=0, inc=600, twist=0;
Angle d_azim=0, d_inc=0;

short mx, my, omx, omy, nmx, nmy;
long origx, origy, sizex, sizey;

int y;
long mode, playmode;
int active=TRUE;
long gid;
#define	TIMELINES	1
#define	FREQLINES	2
#define	AMPLINES	4

int low_res, low_tmp;

int function = 0;
#define REORIENT 1
#define REDISTANCE 2
#define PREPAREAIFF 3

#define DTHETA 0.6
#define PWRMAX 100.0

int idur=0;
float maxpwr = PWRMAX;
float pwr = 1.0;
int facing = 0, facingz = 0, buggy = 0, buggyview = 0;

float p1[ 3], p2[ 3], tv1[ 3], tv2[ 3];
int dotmesh;

short	mute;		/* if TRUE then don't play sound out */
char*	sounds_dir;	/* path to find sample sounds */
#define DEFAULT_SOUNDDIR        "/usr/demos/data/audio"
#define	FIRSTTIME	1
#define	INPORT		2
#define	OUTPORT		4

/* all sound files found in the sound directory are kept in a list */
struct sndfile {
  struct sndfile*	next;
  char*			name;
};
struct sndfile*	sfilelist;
char		SoundsMenu[4096];
long		num_sounds,
		audiosource;

/* pop-up menu id's */
long	mainmenu, linemenu, samplemenu, wheelmenu, drawmenu;

typedef         void (* ALerrfunc) (long, const char*, ...);

static void drawpower();
static void mappower();
static void drawaxis();

void	ringbell(void)
{
}

static void	generate(void)
{
	for (int id=0;id<MAXDURATION;id++)
		for (int io=0;io<ORDER;io++)
			amp[id][io] =  0.0;
}

static void	place(void)
{
	int	nxt = idur;

	for (int id=0;id<DURATION;id++) {
		for (int io=0;io<ORDER;io++) {
			power[id][io][0] = ((float)io+1); /* x */
			power[id][io][1] = amp[nxt][io];            /* y */
			power[id][io][2] = -((float)(id)); /* z */
		}
		nxt--;
		if (nxt < 0 ) nxt = MAXDURATION-1;
	}
}


static void	drawbuggy(void)
{
	int lowx = 20;
	int lowz = -10;

	float gravity = -0.01;
	float bikelength = 3;
	float t1ypos, t2ypos, t1yprev, t2yprev;

	static float thetaa = 0.0;

	p1 [0] = ORDER/2 + facing;
	p1 [2] = -DURATION/2 + facingz;
	p2 [0] = ORDER/2 + facing;
	p2 [2] = -DURATION/2 +facingz - bikelength;

	t1ypos = power[ -(int)p1[2]][(int)p1[0]][1]/maxpwr;
	t2ypos = power[ -(int)p2[2]][(int)p2[0]][1]/maxpwr;

	t1yprev = power[ -(int)p1[2]-1][(int)p1[0]][1]/maxpwr;
	t2yprev = power[ -(int)p2[2]-1][(int)p2[0]][1]/maxpwr;

	tv1 [1] += ( p1[ 1] > t1ypos) ? gravity : t1ypos - t1yprev;
	tv2 [1] += ( p2[ 1] > t2ypos) ? gravity : t2ypos - t2yprev;

	p1[ 1] += tv1[ 1];
	p2[ 1] += tv2[ 1];

	if ( p1[ 1] < 0.0) {
	    p1[ 1] = 0.0;
	    tv1[ 1] *= - 0.2;
	    }
	if ( p2[ 1] < 0.0) {
	    p2[ 1] = 0.0;
	    tv2[ 1] *= -0.2;
	    }

  if ( buggy && !buggyview) {
	pushmatrix();
	scale(1.0, 1.0/20.0, (float)DURATION/(float)ORDER);
	rotate(900, 'y');
	pushmatrix();
	translate((-p1[2] + 1) * ((float)ORDER/(float)DURATION),
		1 + p1[1]*20.0, p1[0]-0.05);

	if (cmapmode) color(7); else RGBcolor(0xff,0xff,0xff);
	circi( 0, 0, 1);
	translate( 0, 0, 0.1);
	circi( 0, 0, 1);
	popmatrix();
	
	if ( p1[ 1] > 0.5) thetaa+= DTHETA/2.0;
	else thetaa += DTHETA;
	if ( thetaa > TWOPI) thetaa-=TWOPI;

	if (cmapmode) color(1); else RGBcolor(0xff,0,0);
	move((-p1[2] + 1) * ((float)ORDER/(float)DURATION) + 0.9 *
		sinf(thetaa), p1[1]*20.0 + 1 - 0.9 * cosf(thetaa), p1[0]);
	draw((-p1[2] + 1) * ((float)ORDER/(float)DURATION) - 0.9 *
		sinf(thetaa), p1[1]*20.0 + 1 + 0.9 * cosf(thetaa), p1[0]);
	move((-p1[2] + 1)  * ((float)ORDER/(float)DURATION) - 0.9 *
		sinf(thetaa + TWOPI/4.0), p1[1]*20.0 + 1 + 0.9 *
		cosf(thetaa + TWOPI/4.0), p1[0]);
	draw((-p1[2] + 1)  * ((float)ORDER/(float)DURATION) + 0.9 *
		sinf(thetaa + TWOPI/4.0), p1[1]*20.0 + 1 - 0.9 * 
		cosf(thetaa + TWOPI/4.0), p1[0]);

	popmatrix();
    }
}	

static void	draw_scene(void) 
{
    if (cmapmode) color(0);
    else RGBcolor(00,00,00);
    clear();
    pushmatrix();
    if (buggyview) lookat (p1[ 0] - ORDER/2, ORDER/DURATION * (- p1[ 2] - 14),
		20.0*p1[ 1] + 2, p1[ 0] - ORDER/2,
		ORDER/DURATION * (- p1[ 2] - 14) - DURATION,
		(20.0*p1[ 1] + 2) / 4.0, 1800);
    else polarview(dist+d_dist, azim+d_azim, inc+d_inc, twist);
    rotate(900, 'x');
    translate(-ORDER/2.0, 0.0, ORDER/2.0);
    scale(1.0,20.0, ORDER/DURATION);

    place();
    if (cmapmode) mappower();
    else drawpower();
    //drawaxis();
    if ( buggy || buggyview) drawbuggy();
    popmatrix();

    if (DB) swapbuffers();
}

static void	mappower(void) 
{
    float	dx,dz,xp,zp;
    int ORD2 = ORDER >> 1,
	bright,
	id, io,
	rc, gc, bc;

    dx = 1.0;
    framecount++;
    linewidth(curlinewidth);
    if (mono) rc = gc = bc = 0x60;
    if (mode & TIMELINES) {
	xp = 0.0;
	dz = -1.0;
	for(io=0;io<ORDER; io++) {
		zp = 0.0;
		move(xp,0,0);
		if (!mono) {
		    rc = (io <= ORD2) ? (0xff*(ORD2-io)/ORDER) : 0;
		    gc = (io <= ORD2) ? (0xff*(io)/ORDER) :
			0xff*(ORDER-io)/ORDER;
		    bc = (io <= ORD2) ? 0 :  (0x80*io)/ORDER;
		}
		for (id=0;id<DURATION;id++) {
		    bright = int((0x3f* ((power[id][io][1]))/maxpwr) + 0x40);	
		    rgbi(rc+bright,gc+bright,gc+bright);
		    draw(xp,power[id][io][1]/maxpwr,zp);
		    zp += dz;
		}
		xp += dx;
	}
    }
    if (mode & FREQLINES) {
	dz = 1.0;
	zp = -DURATION+dz;
	for(id=DURATION-1;id>=0; id--) {
	    xp = 0.0;
	    move(0,((power[id][0][1]))/maxpwr,zp);
	    for (io=0;io<ORDER;io++) {
		if (!mono) {
		    rc = (io <= ORD2) ? (0xff*(ORD2-io)/ORDER) : 0;
		    gc = (io <= ORD2) ? (0xff*(io)/ORDER) :
			0xff*(ORDER-io)/ORDER;
		    bc = (io <= ORD2) ? 0 : (0x80*io)/ORDER;
		}
		bright = int((0x3f* ((power[id][io][1]))/maxpwr) + 0x40);	
		if ( power[id][io][1] > maxpwr) bright = 0xff;
		bright = int((0x8* ((power[id][io][1]))/maxpwr));	
		rgbi(rc+bright,gc+bright,bc+bright);
		draw(xp,power[id][io][1]/maxpwr,zp);
		xp += dx;
	    }
	    zp += dz;
	}
    }
    if (mode & AMPLINES) {
	xp = 0.0;
	dz = -1.0;
	for(io=0;io<ORDER; io++) {
	    zp = 0.0;
	    if (!mono) {
		rc = (io <= ORD2) ? (0xff*(ORD2-io)/ORDER) : 0;
		gc = (io <= ORD2) ? (0xff*(io)/ORDER) : 0xff*(ORDER-io)/ORDER;
		bc = (io <= ORD2) ? 0 : (0x80*io)/ORDER;
	    }
	    for (id=0;id<DURATION;id++) {
		bright = int((0x3f* ((power[id][io][1]))/maxpwr) + 0x40);	
		rgbi(rc+bright,gc+bright,gc+bright);
		move(xp,0.0,zp);
		draw(xp,power[id][io][1]/maxpwr,zp);
		zp += dz;
	    }
	    xp += dx;
	}
    }
}

static void	drawpower(void) 
{
    float	dx,dz,xp,zp;
    int	ORD2 = ORDER >> 1,
	bright,
	id,io,
	rc,gc,bc;

    dx = 1.0;
    framecount++;
    linewidth(curlinewidth);
    if (mono) {
	rc = 0x00;
	gc = 0x80;
	bc = 0x00;
    }
    if (mode & TIMELINES) {
	xp = 0.0;
	dz = -1.0;
	for(io=0;io<ORDER; io++) {
	    zp = 0.0;
	    move(xp,0,0);
	    if (!mono) {
		rc = (io <= ORD2) ? (0xff*(ORD2-io)/ORDER) : 0;
		gc = (io <= ORD2) ? (0xff*(io)/ORDER) : 0xff*(ORDER-io)/ORDER;
		bc = (io <= ORD2) ? 0 : (0x80*io)/ORDER;
	    }
	    for (id=0;id<DURATION;id++) {
		bright = int((0x3f* ((power[id][io][1]))/maxpwr) + 0x40);	
		if ( power[id][io][1] > maxpwr) bright = 0xff;
		cpack ( (rc+bright&0xff) |
			(((gc+bright)<<8)&0xff00) |
			(((bc+bright) << 16)&0xff0000));
		draw(xp,power[id][io][1]/maxpwr,zp);
		zp += dz;
	    }
	    xp += dx;
	}
    }
    if (mode & FREQLINES) {
	dz = 1.0;
	zp = -DURATION+dz;
	for(id=DURATION-1;id>=0; id--) {
	    xp = 0.0;
	    move(0,((power[id][0][1]))/maxpwr,zp);
	    for (io=0;io<ORDER;io++) {
		if (!mono) {
		    rc = (io <= ORD2) ? (0xff*(ORD2-io)/ORDER) : 0;
		    gc = (io <= ORD2) ? (0xff*(io)/ORDER) :
			0xff*(ORDER-io)/ORDER;
		    bc = (io <= ORD2) ? 0 :  (0x80*io)/ORDER;
		}
		bright = int((0x3f* ((power[id][io][1]))/maxpwr) + 0x40);	
		if ( power[id][io][1] > maxpwr) bright = 0xff;
		cpack ( (rc+bright&0xff) |
			(((gc+bright)<<8)&0xff00) |
			(((bc+bright) << 16)&0xff0000));
		draw(xp,power[id][io][1]/maxpwr,zp);
		xp += dx;
	    }
	    zp += dz;
	}
    }
    if (mode & AMPLINES) {
	xp = 0.0;
	dz = -1.0;
	for(io=0;io<ORDER; io++) {
	    zp = 0.0;
	    if (!mono) {
		rc = (io <= ORD2) ? (0xff*(ORD2-io)/ORDER) : 0;
		gc = (io <= ORD2) ? (0xff*(io)/ORDER) : 0xff*(ORDER-io)/ORDER;
		bc = (io <= ORD2) ? 0 :  (0x80*io)/ORDER;
	    }
	    for (id=0;id<DURATION;id++) {
		bright = int((0x3f* ((power[id][io][1]))/maxpwr) + 0x40);	
		if ( power[id][io][1] > maxpwr) bright = 0xff;
		cpack ( (rc+bright&0xff) |
			(((gc+bright)<<8)&0xff00) |
			(((bc+bright) << 16)&0xff0000));
		move(xp,0.0,zp);
		draw(xp,power[id][io][1]/maxpwr,zp);
		zp += dz;
	    }
	    xp += dx;
	}
    }
}


static void	drawaxis(void)
{
	move(0.0, 0.0, 0.0);
	cpack(0xff);
	draw(ORDER, 0.0, 0.0);
	move(0.0, 0.0, 0.0);
	cpack(0xff00);
	draw(0.0,.50, 0.0);
	move(0.0, 0.0, 0.0);
	cpack(0xff0000);
	draw(0.0, 0.0, -DURATION);
}

static void	initialize(void)
{
    gid = winopen("Visual Audio");

    if (DB) doublebuffer();
    if(getgdesc(GD_BITS_NORM_SNG_RED) == 0) candoRGB = 0;
    else candoRGB = 1;
    if (!candoRGB) cmapmode = 1;
    if (cmapmode) cmode(); else RGBmode();
    shademodel( FLAT);
    zbuffer(FALSE);
    gconfig();
    if (cmapmode ) color(0); else RGBcolor(0, 0, 0);
    clear();
    if(DB)  { swapbuffers(); clear(); }
    qdevice(INPUTCHANGE);
    qdevice(REDRAW);
    qdevice(ESCKEY);
    qdevice(WINQUIT);
    qdevice(WINSHUT);
    qdevice(WINFREEZE);
    qdevice(WINTHAW);
    qdevice(LEFTMOUSE);
    qdevice(MIDDLEMOUSE);
    qdevice(RIGHTMOUSE);
    qdevice(RKEY);			/* replay current sample */
    qdevice(LEFTARROWKEY);		/* following four move wheel */
    qdevice(RIGHTARROWKEY);
    qdevice(UPARROWKEY);
    qdevice(DOWNARROWKEY);
    qdevice(BKEY);			/* Toggle wheel on/off */
    qdevice(VKEY);			/* Toggle view from/of wheel */
    qdevice(SKEY);			/* Resynchronize without popup menu */

    p1[ 0] = p1[ 1] = p1[ 2] = p2[ 0] = p2[ 1]= p2[2] = v1[ 0] = v1[ 1] =
		v1[ 2] = v2[ 0] = v2[ 1]= v2[ 2] = 0.0;
    generate();
    dist = DURATION * 3;

    perspective(600, 5.0/4.0, 0, DURATION*3.0);

    qreset();
    qenter(REDRAW, (short)winget());
}

extern "C" ALerrfunc ALseterrorhandler(ALerrfunc efunc); 

static void efunc( long num, const char * ch, ...)
{
}

/* func is given by a logical or of OUTPORT and INPORT */
static void	close_audio(short func)
{
	if ((func & INPORT) && port) { ALcloseport(port); port = 0; }
	if ((func & OUTPORT) && outport) { ALcloseport(outport); outport = 0; }
}

/* func is given by logical or of FIRSTTIME, OUTPORT, and INPORT */
static void	open_audio(short func)
{
	ALerrfunc	origfunc;
	short		badopen = 0;

	origfunc = ALseterrorhandler(efunc);
	if (func & FIRSTTIME) {
	    conf = ALnewconfig();
	    ALsetwidth(conf, AL_SAMPLE_16);
	    outport = port = 0;
	}
	if (func & INPORT) badopen = badopen ||
		((port = ALopenport("audio_in", "r", conf)) == 0);
	if ((func & OUTPORT) && !mute) badopen = badopen ||
		((outport = ALopenport("audio_out", "w", conf)) == 0);
	if (badopen) {
	    fprintf(stderr, "%s: could not open the necessary audio ports\n",
		myname);
	    system("inform 'could not open the audio ports'");
	    exit(1);
	}
	ALseterrorhandler(origfunc);
}

static void	resynchronize(void)
{
	close_audio(INPORT | OUTPORT);
	open_audio(INPORT | OUTPORT);
}

static void	find_sounds(char* sound_dir)
{
	char		menuentry[256], path[512], magicbuf[12];
	DIR*		dir;
	FILE*		sf;
	struct direct*	entry;
	struct sndfile*	listel, **prev = &sfilelist;

	num_sounds = 0;
	if ((dir = opendir(sound_dir)) == NULL) {
		fprintf(stderr,"%s: could not find sounds directory %s\n",
			myname, sound_dir);
		system("inform 'could not find sounds-directory'");
		return;
	}

	while ((entry = readdir(dir)) != NULL) {
		if (strcmp(entry->d_name, ".") == 0 ||
			strcmp(entry->d_name, "..") == 0) continue;

                strcpy(path, sound_dir);
                strcat(path, "/");
                strcat(path, entry->d_name);

		/* only list files with right magic */
		if ((sf = fopen(path, "r")) == 0) continue;
		fread(magicbuf, sizeof(char), 12, sf);
		fclose(sf);
		if (strncmp(magicbuf, "FORM", 4) != 0 ||
			strncmp(magicbuf+8, "AIFF", 4) != 0) continue;

		if ((listel = (struct sndfile*) malloc(sizeof(struct sndfile)))
			== 0) break;
		if ((listel->name = (char*) malloc(strlen(path) + 1)) == 0)
			break;
		strcpy(listel->name, path);
		listel->next = NULL;

		*prev = listel;
		prev = &(listel->next);

		sprintf(menuentry, "|%s%%x%d", entry->d_name, 100+num_sounds++);
		strcat(SoundsMenu, menuentry);
	}
}

static void	remake_lmenu(void)
{
	long i;

	freepup(linemenu);
	linemenu = defpup("Line Widths %t| One %x11| Two %x12| Four %x14| Six %x16");
	for (i = 0; i < 4; i++)
	    setpup(linemenu, i+1, PUP_BOX);
	switch (curlinewidth) {
	    case 1: i = 1; break;
	    case 2: i = 2; break;
	    case 4: i = 3; break;
	    case 6: i = 4; break;
	    default: curlinewidth = 1; i = 1; break;
	}
	setpup(linemenu, i, PUP_CHECK);
}

static void	remake_dmenu(void)
{
	long i;

	freepup(drawmenu);
	drawmenu = defpup("Draw modes %t|Draw Time %x8|Draw Frequency %x9|Draw Amplitude %x10");
	for (i = 0; i < 3; i++)
	    setpup(drawmenu, i+1, (mode & (TIMELINES << i)) ?
		PUP_CHECK : PUP_BOX);
}

static void	remake_wmenu(void)
{
	freepup(wheelmenu);
	wheelmenu = defpup("Wheel Options %t|Wheel %x5|Wheel View %x6");
	setpup(wheelmenu, 1, buggy ? PUP_CHECK : PUP_BOX);
	setpup(wheelmenu, 2, buggyview ? PUP_CHECK : PUP_BOX);
}

static void	remake_smenu(void)
{
	long i;
	long parambuf[2];

	for (i = 0; i < num_sounds+3; i++)
	    setpup(samplemenu, i+1, PUP_BOX);
	if (playmode == 1) {
	    parambuf[0] = AL_INPUT_SOURCE;
	    ALgetparams(AL_DEFAULT_DEVICE, parambuf, 2);
	    switch (parambuf[1]) {
		case AL_INPUT_MIC: audiosource = 0; break;
		case AL_INPUT_LINE: audiosource = 1; break;
		case AL_INPUT_DIGITAL: audiosource = 2; break;
		default: audiosource = 1; break;
	    }
	    setpup(samplemenu, audiosource+1, PUP_CHECK);
	}
	else
	    setpup(samplemenu, audiosource+4, PUP_CHECK);
}

static void	remake_mmenu(void)
{
	if (mono) setpup(mainmenu, 3, PUP_BOX);
	else setpup(mainmenu, 3, PUP_CHECK);
	if (!candoRGB) setpup(mainmenu, 4, PUP_GREY);
	else if (cmapmode) setpup(mainmenu, 4, PUP_BOX);
	else setpup(mainmenu, 4, PUP_CHECK);
	if (mute) setpup(mainmenu, 7, PUP_CHECK);
	else setpup(mainmenu, 7, PUP_BOX);
}

static void	remake_menus(void)
{
	freepup(mainmenu);
	mainmenu = defpup("Visual Audio %t|Draw Modes %x0%m|Line Width %x0%m|Color %x2|RGB %x3|Source %x0%m|Wheel %x0%m|Mute %x4|Quit %x1", drawmenu, linemenu, samplemenu, wheelmenu);
	remake_mmenu();
}

static void	make_menus(void)
{
	remake_lmenu();
	remake_wmenu();
	remake_dmenu();
	samplemenu = defpup(SoundsMenu);
	remake_smenu();
	remake_menus();
}

static int	wait_till_thawed(void)
{
	long	dev;
	short	val;

        close_audio(INPORT | OUTPORT);
	do {
		dev = qread(&val);
	} while (dev != WINQUIT && dev != WINSHUT && dev != WINTHAW);
	if (dev == WINQUIT || dev == WINSHUT) return TRUE;
	open_audio(INPORT | OUTPORT);
	qenter(REDRAW, (short)winget());
	return FALSE;
}

static void	usage(void)
{
	fprintf(stderr,"usage: %s [-c] [-m] [-r] [samples-directory]\n",myname);
	system("inform 'usage: amesh [-c] [-m] [-r] [samples-directory]'");
	exit(1);
}

static void	parse(int argc, char** argv)
{
	char*	sounds_dir = 0;
	int	i;

	myname = argv[0];

	for (i = 1; i < argc; i++) {
	    if (argv[i][0] == '-') {
		if (argv[i][1] != 0 && argv[i][2] == 0) switch (argv[i][1]) {
		    case 'c':  cmapmode = !0; break;
		    case 'm':  mute = !0; break;
		    case 'r':  cmapmode = 0; break;
		    default: usage();
		}
		else usage();
	    }
	    else {
		if (sounds_dir) usage();
		sounds_dir = argv[i];
	    }
	}
	if (!sounds_dir) find_sounds(DEFAULT_SOUNDDIR);
	else find_sounds(sounds_dir);
}

void main( int argc, char **argv) 
{
    long	xrot,yrot,zrot;
    int		compute;
    long	i, ntoread, dev, samplenum;
    int		spin = 0, l=0, nframe=0;
    short	done = FALSE, stowed = FALSE, val, getaiff = 0;
    char	samplename[512];
    AIFFfile aifffile = -1;
    long	aifflength, pvbuf[2], outrate,
		fudge_count = FUDGE;
    float	time_per_frame = 0.0, timefact = 1.0, basetime = 0.0;

    mute = 0;	/* default no echoing */

    strcpy(SoundsMenu, "Source%t|Mic in%x21|Line in%x22|Digital In%x23");

    cmapmode = !0;
    parse(argc, argv);

    for (i=0;i<8000;i++) tbuf[i] = (SAMPLE) ( (i*8)%256 - 128 );
    xrot = yrot = zrot = 0;
    dotmesh = 0;

    compute = 1;

    open_audio(FIRSTTIME | INPORT | OUTPORT);

    initialize();

    idur = 0;

    if (port) ALsetfillpoint(port, (ALgetqueuesize(conf) - BUFCHUNKSIZE));
    pvbuf[ 0] = AL_INPUT_RATE;
    ALgetparams( AL_DEFAULT_DEVICE, pvbuf, 2);
    outrate = pvbuf[ 1];
    pvbuf[ 0] = AL_OUTPUT_RATE;
    ALsetparams( AL_DEFAULT_DEVICE, pvbuf, 2);
    pvbuf[0] = AL_INPUT_SOURCE;
    ALgetparams(AL_DEFAULT_DEVICE, pvbuf, 2);
    switch (pvbuf[1]) {
	case AL_INPUT_MIC: audiosource = 0; break;
	case AL_INPUT_LINE: audiosource = 1; break;
	case AL_INPUT_DIGITAL: audiosource = 2; break;
    }
    playmode = 1;
    mode = FREQLINES;

    make_menus();

    resynchronize();

    while (!done) {
	draw_scene();
	idur++;
	if (idur >= MAXDURATION) idur = 0;

	if (playmode != 2 && port) {
	    long nfilled = ALgetfilled(port);
	    ntoread = nfilled > ABUFFERSIZE ? ABUFFERSIZE : nfilled;
	}

	if (playmode == 1) ALreadsamps(port, (void *) tbuf, ntoread);
	else if (playmode == 2) {
	    aifflength = AIFFread(aifffile, (void *) tbuf,
		(int)(time_per_frame * timefact * (float)  outrate * 2));
	    if (aifflength == 0) {
		playmode = 0;
		AIFFclose(aifffile);
	    }
	    if (aifflength < BUFCHUNKSIZE)
		for (i = aifflength; i < BUFCHUNKSIZE; i++) tbuf[ i] = 0;
	}
	else if (playmode == 0) {
	    for (i = 0; i < ABUFFERSIZE; i++) tbuf[ i] = 0;
	    ntoread = BUFCHUNKSIZE;
	}
	     

	if (fudge_count && playmode != 2) {
	    time_per_frame += (float) ntoread / (float) (outrate * 2);
	    fudge_count--;
	    if ( fudge_count == 0) time_per_frame /= (float) (FUDGE + 3);
	    time_per_frame += 0.02;
	    basetime = time_per_frame;
	}
		
	if ((playmode == 1) || (playmode == 0)) {	
/* never passthrough input to output, only play samples
	    if (playmode == 1 && !mute && outport)
		ALwritesamps(outport, (void*) tbuf, ntoread);
*/
	    pwr = spectrum(tbuf+(ntoread-BUFCHUNKSIZE), 
			BUFCHUNKSIZE, &amp[idur][0], ORDER, 0 );
	}
	else if (playmode == 2) {
	    if (!mute && outport) {
	        while (ALgetfilled(outport) >
			(int)(0.01 * (float)outrate * 2.0));
		ALwritesamps(outport, (void *) tbuf, aifflength);
	    }
	    pwr = spectrum(tbuf+(aifflength-BUFCHUNKSIZE), 
			BUFCHUNKSIZE, &amp[idur][0], ORDER, 0 );
	}
	if (pwr < maxpwr) nframe++;
	if (nframe > DURATION) { nframe = 0; maxpwr *= 0.97;}
	if (pwr > maxpwr) { maxpwr = pwr; nframe = 0 ;}

	timefact = 1.0;

	    /* Thant's input code */
	while(qtest() /*  || (!function && low_tmp<2) */ ) {
	    dev=qread(&val);
	    switch(dev) {
		case INPUTCHANGE:
		    active = val;
		    break;
		case WINQUIT:
		case WINSHUT: done = TRUE; break;
		case WINFREEZE: stowed = TRUE; break;
		case ESCKEY :
		    if (!val) done = TRUE;
		    break;
		case SKEY:
		    if ( val == 0) break;
		    resynchronize();
		    break;
		case VKEY:
		    if (( val == 0) || (!buggy)	) break;
		    buggyview = !buggyview;
		    break;
		case LEFTMOUSE:
		    mx = (short) getvaluator(MOUSEX);
		    my = (short) getvaluator(MOUSEY);
		    timefact *= LMTIMEFACT;
		    if (val) {
			function=REDISTANCE;
			setvaluator(MOUSEX, mx,(short) origx+1,
				(short)(origx+sizex-1));
			setvaluator(MOUSEY, my,(short) origy+1,
				(short)(origy+sizey-1));
			omx = mx; omy = my;
		    } else {
			function=0;
			setvaluator(MOUSEX, mx, 0, XMAXSCREEN);
			setvaluator(MOUSEY, my, 0, YMAXSCREEN);
			dist += d_dist; d_dist = 0.0;
		    }
		    break;
		case MIDDLEMOUSE:
		    timefact *= MMTIMEFACT;
		    mx = (short)getvaluator(MOUSEX);
		    my = (short)getvaluator(MOUSEY);
		    if (val) {
			function=REORIENT;
			setvaluator(MOUSEX, mx, (short)origx+1,
				(short)(origx+sizex-1));
			setvaluator(MOUSEY, my, (short)origy+1,
				(short)(origy+sizey-1));
			omx = mx; omy = my;
		    } else {
			function=0;
			setvaluator(MOUSEX, mx, 0, XMAXSCREEN);
			setvaluator(MOUSEY, my, 0, YMAXSCREEN);
			azim += d_azim; d_azim = 0;
			inc += d_inc; d_inc = 0;
		    }
		    break;
		case RIGHTMOUSE:
		    if (val) {
			long menval;
			remake_smenu();
			menval = dopup(mainmenu);
			resynchronize();
			switch (menval) {
			    case -1: break;
			    case 1: /* quit */
				done = 1;
				break;
			    case 2: /* color */
				mono ^= 1;
				remake_mmenu();
				break;
			    case 3: /* RGB */
				if (cmapmode = !(cmapmode && candoRGB)) cmode();
				else RGBmode();
				gconfig();
				remake_mmenu();
				break;
			    case 4: /* mute */
				mute ^= 1;
				if (mute) close_audio(OUTPORT);
				else open_audio(OUTPORT);
				remake_mmenu();
				break;
			    case 5: /* wheel toggle */
				buggy ^= 1;
				remake_wmenu();
				remake_menus();
				break;
			    case 6: /* wheel view toggle */
				buggyview ^= 1;
				remake_wmenu();
				remake_menus();
				break;
			    case 8: /* toggle time */
				mode ^= TIMELINES;
				goto fix_time_per_frame;
			    case 9: /* toggle frequency */
				mode ^= FREQLINES;
				goto fix_time_per_frame;
			    case 10: /* toggle amplitude */
				mode ^= AMPLINES;
fix_time_per_frame:
				remake_dmenu();	/* also fixup menu	*/
				remake_menus();
				/* nothing yet */
				break;
			    case 11: case 12: case 13: case 14:
			    case 15: case 16: case 17: case 18: case 19:
				curlinewidth = (int)(menval-10);
				remake_lmenu();
				remake_menus();
				break;
			    case 21:
			    case 22:
			    case 23:
				generate();
				playmode = 1;
				pvbuf[0] = AL_INPUT_RATE;
				ALgetparams(AL_DEFAULT_DEVICE, pvbuf, 2);
				pvbuf[0] = AL_OUTPUT_RATE;
				ALsetparams(AL_DEFAULT_DEVICE, pvbuf, 2);
				maxpwr = PWRMAX;
				switch (menval) {
				    case 21: pvbuf[1] = AL_INPUT_MIC; break;
				    case 22: pvbuf[1] = AL_INPUT_LINE; break;
				    case 23: pvbuf[1] = AL_INPUT_DIGITAL;
				}
				pvbuf[0] = AL_INPUT_SOURCE;
				ALsetparams(AL_DEFAULT_DEVICE, pvbuf, 2);
				audiosource = menval - 21;
				remake_smenu();
				remake_menus();
				break;
			    default:
				if (menval >= 100) {
				    struct sndfile* scan = sfilelist;

				    for (samplenum = 100; samplenum < menval;
					samplenum++) scan = scan->next;
				    playmode = 2;
				    getaiff = !0;
				    strcpy(samplename, scan->name);
				    audiosource = samplenum-100;
				    remake_smenu();
				    remake_menus();
				}
				break;
			}
		    }
		    break;
		case REDRAW:
		    reshapeviewport();
		    getorigin(&origx, &origy);
		    getsize(&sizex, &sizey);
		    resynchronize();
		    break;
		case RKEY:
		    if ( val == 0) break;
		    playmode = 2;
		    getaiff = !0;
		    audiosource = samplenum-100;
		    remake_smenu();
		    remake_menus();
		    break;
		case LEFTARROWKEY:
		    if ( val == 0) break;
		    facing += 1;
		    if ( facing + ORDER/2 >= ORDER) facing = -ORDER/2;
		    break;
		case RIGHTARROWKEY:
		    if ( val == 0) break;
		    facing -= 1;
		    if ( facing + ORDER/2 < 0) facing = ORDER/2 - 1;
		    break;
		case UPARROWKEY:
		    if ( val == 0) break;
		    facingz += 1;
		    if ( -DURATION/2 + facingz > 0) facingz = -DURATION/2 + 1;
		    break;
		case DOWNARROWKEY:
		    if ( val == 0) break;
		    facingz -= 1;
		    if ( -DURATION/2 + facingz <= -DURATION) facingz = DURATION/2 ;
		    break;
		case BKEY:
		    if ( val == 0) break;
		    buggy = !buggy;
		    break;
	    }
	}

	switch(function) {

	    case REORIENT:
		mx = (short)getvaluator(MOUSEX);
		my = (short)getvaluator(MOUSEY);
		d_azim = (short)((omx - mx) * 2 * XMAXSCREEN / sizex);
		d_inc = (short)((my - omy) * 2 * YMAXSCREEN / sizey);
		break;

	    case REDISTANCE:
		mx = (short)getvaluator(MOUSEX);
		my = (short)getvaluator(MOUSEY);
		d_dist = ((omx - mx) + (my - omy)) * XMAXSCREEN /sizex;
		break;
	}

	if (getaiff) {
		getaiff = 0;
		if (aifffile != -1) AIFFclose(aifffile);
		generate();
		maxpwr = PWRMAX;
		aifffile = AIFFopen(samplename, "r");
		if ( aifffile == -1) {
		    playmode = 1;
		    remake_smenu();
		    remake_menus();
		}
		ALsetchannels(conf,
			CONVERTchannelstoAL(AIFFgetchannels(aifffile)));
		ALsetwidth(conf, CONVERTwidthtoAL(AIFFgetwidth(aifffile)));
		pvbuf[0] = AL_OUTPUT_RATE;
		outrate = pvbuf[1] = CONVERTratetoAL(AIFFgetrate(aifffile));
		ALsetparams(AL_DEFAULT_DEVICE, pvbuf, 2);
	}

	if (stowed) {
		done = wait_till_thawed();
		stowed = FALSE;
	}

    }
    close_audio(INPORT | OUTPORT);
}

