/*
 * Copyright (C) 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/***************************************************************************
 *
 * BZ - Multiplayer tank game.
 *
 *			        Chris Fouts - Silicon Graphics, Inc.
 *			        October, 1991
 **************************************************************************/

#if !defined( BZBASE_H )
#define BZBASE_H

#include <X11/Intrinsic.h>
#include <gl/gl.h>
#include <stdarg.h>

/* BEGIN PROTOTYPES bzbase.c */
void    drawBaseCB( Widget w, XtPointer client_data, XtPointer call_data ) ;
void    drawOverlay( void ) ;
void    drawRadarCB( Widget w, XtPointer client_data, XtPointer call_data ) ;
void    initBaseGlCB( Widget w, XtPointer client_data, XtPointer call_data ) ;
void    initRadarGlCB( Widget w, XtPointer client_data, XtPointer call_data ) ;
void    init_screen( void ) ;
void    post_new_message( int count, int vocal, char *fmt, ... ) ;
void    print_to_net_debugger( char *fmt, va_list args ) ;
void    radar_view( void ) ;
void    redraw_base_screen( void ) ;
void    set_bulletin_color( Colorindex n ) ;
void    show_flag_status( void ) ;
void    show_gun_status( int n ) ;
void    show_heading( void ) ;
void    show_level( void ) ;
void    show_lives( void ) ;
void    show_mine_status( void ) ;
void    show_msgs( int vocal, int redraw ) ;
void    show_out_message( void ) ;
void    show_players( void ) ;
void    show_score( void ) ;
void    show_speed( void ) ;
void    show_zoom_factor( void ) ;
/* END PROTOTYPES bzbase.c */
#endif /* !defined( BZBASE_H ) */
