/*
 * Copyright (C) 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/***************************************************************************
 *
 * @(#) - BZ - Multiplayer tank game - Collision detection routines.
 *
 *			        Chris Fouts - Silicon Graphics, Inc.
 *			        October, 1991
 **************************************************************************/

#if !defined(BZCOLLIDE_H)
#define BZCOLLIDE_H


#define	MAX_Y_SIDE	1
#define	MAX_X_SIDE	2
#define	MIN_Y_SIDE	3
#define	MIN_X_SIDE	4


/* BEGIN PROTOTYPES bzcollide.c */
int     check_line_to_rect( float self[2][2], float obstacle[4][2],
            int closest ) ;
int     check_mine_hit( unsigned int *enemy_id, float radius ) ;
int     check_missile_hit( int tank_id, unsigned int *obst_id, int *side ) ;
int     check_tank_collision( unsigned int tank_id, unsigned int *obst_id ) ;
int     id_tank( void ) ;
int     intersection_check( float r0[2], float r1[2], float r2[2],
            float r3[2], float *s ) ;
void    locate_obstacle_corner_points( int obst_id, float pt[4][2],
            float scaling ) ;
void    locate_tank_corner_points( int tank_id, float pt[4][2] ) ;
/* END PROTOTYPES bzcollide.c */

#endif /* !defined(BZCOLLIDE_H) */
