/*
 * Copyright (C) 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/***************************************************************************
 *
 * @(#) - BZ - Multiplayer tank game.
 *
 *			        Chris Fouts - Silicon Graphics, Inc.
 *			        October, 1991
 **************************************************************************/

#if !defined(BZOBJS_H)

#define BZOBJS_H

/* BEGIN PROTOTYPES bzobjs.c */
void        bind_lighting( void ) ;
GL_Object   create_logo( unsigned char *logodata, int set_color,
                int *logo_side ) ;
void        draw_dark_surface( float *desc ) ;
void        draw_surface( float *desc ) ;
void        draw_tank( int type, int view, int k, int p ) ;
void        draw_tex_surface( float *desc ) ;
void        init_color( int map, Widget widget ) ;
void        init_lighting( void ) ;
void        init_overlay_color( Widget w ) ;
void        make_all( void ) ;
void        make_crosshairs( void ) ;
void        make_expl( void ) ;
void        make_flags( void ) ;
void        make_fonts( void ) ;
void        make_ground( void ) ;
void        make_missile( void ) ;
void        make_mv_objects( void ) ;
void        make_obst( void ) ;
void        make_pieces( unsigned exp_len ) ;
void        make_radar( void ) ;
void        make_sky( void ) ;
void        make_tank( void ) ;
void        normal3f( float ny, float nx, float nz ) ;
GL_Object   read_logo( const char *filename, unsigned char *logodata,
                int size, int set_color, int *logo_side ) ;
void        set_normal( float *desc, int stride ) ;
/* END PROTOTYPES bzobjs.c */

#endif /* !defined(BZOBJS_H) */

#define	BZL_BGNTMESH	0
#define	BZL_SWAPTMESH	1
#define	BZL_ENDBGNTMESH	2
#define	BZL_RETENDTMESH	3
#define	BZL_LEFTSIDE	4
#define	BZL_RIGHTSIDE	5
#define	BZL_NOSIDE		6
