/*
 * Copyright (C) 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/***************************************************************************
 *
 * @(#) - BZ - Multiplayer tank game - Screen Scaling header.
 *
 * $Id: bzscreen.h,v 1.4 1993/08/11 19:46:25 adele Exp $
 *
 *			        Chris Fouts - Silicon Graphics, Inc.
 *			        October, 1991
 **************************************************************************/

#if !defined(BZSCREEN_H)

#define BZSCREEN_H

#if defined(BZSCREEN_INTERNAL)

#define HORZ_GAP	0.024438f

#define RADAR_L	0.386119f
#define RADAR_R	0.614858f
#define RADAR_B	0.013038f
#define RADAR_T	0.318123f

#define HEAD_L	0.297165f
#define HEAD_R	0.361681f
#define HEAD_B	0.288136f
#define HEAD_T	0.318123f

#define SCORE_L	0.639296f
#define SCORE_R	0.703812f
#define SCORE_B	0.288136f
#define SCORE_T	0.318123f

#define MESGS_L	0.009775f
#define MESGS_R	0.272727f
#define MESGS_B	0.052151f
#define MESGS_T	0.318123f

#define OUTMS_L	0.728250f
#define OUTMS_R	0.991202f
#define OUTMS_B	0.298566f
#define OUTMS_T	0.318123f

#define LIVES_L	0.782014f
#define LIVES_R	0.823069f
#define LIVES_B	0.202086f
#define LIVES_T	0.232073f

#define LEVEL_L	0.847507f
#define LEVEL_R	0.888562f
#define LEVEL_B	LIVES_B
#define LEVEL_T	LIVES_T

#define NOPLY_L	0.728250f
#define NOPLY_R	0.757576f
#define NOPLY_B	LIVES_B
#define NOPLY_T	LIVES_T

#define MVIEW_L	0.009775f
#define MVIEW_R	0.990225f
#define MVIEW_B	0.346806f
#define MVIEW_T	0.986962f

#define GROND_L	0.009775f
#define GROND_R	0.990225f
#define GROND_B	0.346806f
#define GROND_T	0.664928f

#define GUIDE_L	0.107527f
#define GUIDE_R	0.892473f
#define GUIDE_B	0.411995f
#define GUIDE_T	0.921773f

#define LOADM_L	0.297165f
#define LOADM_R	0.361681f
#define LOADM_B	LIVES_B
#define LOADM_T	LIVES_T

#define READY_L	0.639296f
#define READY_R	0.703812f
#define READY_B	LIVES_B
#define READY_T	LIVES_T

#define RIGHT_L	0.661779f
#define RIGHT_R	0.681329f
#define RIGHT_B	0.052151f
#define RIGHT_T	0.146023f

#define LEFTT_L	0.319648f
#define LEFTT_R	0.339198f
#define LEFTT_B	0.052151f
#define LEFTT_T	0.146023f

#define LOGOD_L	0.845179f
#define LOGOD_R	0.991202f
#define LOGOD_B	0.000000f
#define LOGOD_T	0.146023f

#define MINES_L	( LEVEL_R + HORZ_GAP )
#define MINES_R	( MINES_L + 0.025f )
#define MINES_B	LIVES_B
#define MINES_T	LIVES_T

#define FLAGS_L	( MINES_R + HORZ_GAP )
#define FLAGS_R	( FLAGS_L + 0.025f )
#define FLAGS_B	LIVES_B
#define FLAGS_T	LIVES_T

#define	FSETUP( v )	FVP##v##_L = VP##v##_L ; \
					FVP##v##_R = VP##v##_R ; \
					FVP##v##_B = VP##v##_B ; \
					FVP##v##_T = VP##v##_T

#define	SETUP( v )	VP##v##_L = (int)( (v##_L) * w + .49f + x_off ) ; \
					VP##v##_R = (int)( (v##_R) * w + .49f + x_off ) ; \
					VP##v##_B = (int)( (v##_B) * h + .49f ) ; \
					VP##v##_T = (int)( (v##_T) * h + .49f ) ; \
					FSETUP( v )

#define	DECLARE( v )	int VP##v##_L, VP##v##_R, VP##v##_B, VP##v##_T ; \
			float FVP##v##_L, FVP##v##_R, FVP##v##_B, FVP##v##_T

#else /* defined(BZSCREEN_INTERNAL) */

#define	DECLARE( v )	extern int VP##v##_L, VP##v##_R, VP##v##_B, VP##v##_T ; \
			extern float FVP##v##_L, FVP##v##_R, FVP##v##_B, FVP##v##_T

#endif /* else defined(BZSCREEN_INTERNAL) */

#define FRAMEW	9.0f

/* BEGIN PROTOTYPES bzscreen.c */
void    get_screen_dimensions( void ) ;
void    set_up_screen_dimensions( void ) ;
/* END PROTOTYPES bzscreen.c */

#endif /* !defined(BZSCREEN_H) */
