/*
 * Copyright (C) 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/***************************************************************************
 *
 * @(#) - BZ - Multiplayer tank game - Sound support header.
 *
 *			        Chris Fouts - Silicon Graphics, Inc.
 *			        October, 1991
 **************************************************************************/

#if !defined(BZSOUND_H)

#define BZSOUND_H

#define SFX_DROP_MINE		0
#define SFX_PICK_UP_MINE	1
#define SFX_EXPLOSION		2
#define SFX_FIRE			3
#define SFX_BUMP			4
#define SFX_POP				5
#define SFX_FLAG_GRABBED	6
#define SFX_FLAG_WON		7
#define SFX_FLAG_LOST		8
#define SFX_PAUSE_REMINDER	9
#define SFX_N_SOUNDS		10

/* BEGIN PROTOTYPES bzsound.c */
void    end_sound( void ) ;
void    explosion_sfx( float x, float y, float heading ) ;
int     init_sound( void ) ;
void    set_volume( int level ) ;
void    sfx( int sound ) ;
int     toggle_sound( void ) ;
int     volume_change( int direction ) ;
/* END PROTOTYPES bzsound.c */

#endif /* !defined(BZSOUND_H) */
