/*
 * Copyright (C) 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/***************************************************************************
 *
 * @(#) - BZ - Multiplayer tank game - Host validation routines
 *
 *			        Chris Fouts - Silicon Graphics, Inc.
 *			        October, 1991
 **************************************************************************/

#if !defined(BZVALIDATE_H)

#define BZVALIDATE_H

/* BEGIN PROTOTYPES bzvalidate.c */
void                add_host_to_census( long id ) ;
void                check_to_send_census( void ) ;
void                dprintf( char *fmt, ... ) ;
void                drop_host( long host_id ) ;
void                dropped_by_host( long host_id ) ;
struct bz_census   *find_host_census( long id ) ;
char               *host_name_from_id( long id ) ;
void                init_census_packet( long id ) ;
void                invalidate_host( long host_id ) ;
char               *print_date( void ) ;
char               *print_time( void ) ;
char               *print_time_hundreths( struct timeval *t ) ;
void                process_bz_census( struct BzCensus *input ) ;
void                quit_host( long host_id ) ;
void                register_key( unsigned short key ) ;
void                remove_host( long host_id ) ;
void                remove_host_from_census( long id ) ;
void                send_acknowledgement( long id ) ;
int                 should_acknowledge( long host_id, unsigned short key ) ;
void                validation_summary( void ) ;
int                 valid_host( long host_id ) ;
int                 valid_keyed_host( long host_id, unsigned short key ) ;
/* END PROTOTYPES bzvalidate.c */

#endif /* !defined(BZVALIDATE_H) */
