/*
 * Copyright (C) 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/***************************************************************************
 *
 * @(#) - BZ - Multiplayer tank game - Framerate Control.
 *
 *			        Chris Fouts - Silicon Graphics, Inc.
 *			        October, 1991
 **************************************************************************/

#if !defined(FRAMERATE_H)

#define FRAMERATE_H
#include <sys/time.h>

/* BEGIN PROTOTYPES framerate.c */
void    add_to_time( struct timeval *dst, long secs, long usecs ) ;
void    copy_time( struct timeval *dst, struct timeval *src ) ;
long    elapsed_sec_tenths( struct timeval *bufThen, struct timeval *bufNow ) ;
float   end_time( struct timeval *bufThen, struct timeval *bufNow ) ;
float   pace_frame( struct timeval *buf ) ;
void    set_frame_rate( int new_rate ) ;
void    set_time( struct timeval *dst, struct timeval *src, long secs,
            long usecs ) ;
void    start_time( struct timeval *buf ) ;
/* END PROTOTYPES framerate.c */

#endif /* !defined(FRAMERATE_H) */
