/*
 * Copyright (C) 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#ifndef BITMAPDEF
#define BITMAPDEF

typedef struct Bitmap {
   	short *base; 		/* pointer to first word */
	short xsize, ysize;	/* dimensions of the bitmap */
	short xorig, yorig;	/* origin - used for cursors */
	short xmove, ymove;	/* move - used by characters */
	short sper;		/* shorts per row */
} Bitmap;

typedef struct Font {
	short descender;
	short width;
	short height;
	short nchars;
	short bitsdeep;
	Bitmap **chars;
} Font;

Bitmap *bmnew();
Bitmap *bmread();
Bitmap *bmfromfile();
Bitmap *bmclone();
Bitmap *bmmagnify();
Bitmap *bmminimize();

Font *fntnew();
Font *fntread();
Font *fntfromfile();
Font *fntclone();
Font *fntmagnify();
Font *fntminimize();
Font *fntgl2cvt();

#define BM_SET	1
#define BM_CLR	2
#define BM_XOR	3

#endif
