/*
 * Copyright (C) 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/***************************************************************************
 * obstacles.h Release 2.14 - 2/27/92 09:45:34
 * Last Change: 2/20/92 12:42:14
 *
 * @(#) - BZ - Multiplayer tank game - Obstacle geometry definitions.
 *
 *			        Chris Fouts - Silicon Graphics, Inc.
 *			        October, 1991
 **************************************************************************/

#if !defined(OBSTACLES_H)

#define OBSTACLES_H

#define CUBE_WIDTH	10.
#define CUBE_HEIGHT	20.

#define PYRM_WIDTH	10.
#define PYRM_HEIGHT	20.

float cube_front[] = {
	1.,
	4.,
	-CUBE_WIDTH, CUBE_WIDTH,          0., 1., 0.,
	-CUBE_WIDTH, CUBE_WIDTH, CUBE_HEIGHT, 1., 1.,
	 CUBE_WIDTH, CUBE_WIDTH,          0., 0., 0.,
	 CUBE_WIDTH, CUBE_WIDTH, CUBE_HEIGHT, 0., 1.,
	} ;
float cube_right[] = {
	1.,
	4.,
	 CUBE_WIDTH,-CUBE_WIDTH,          0., 1., 0.,
	 CUBE_WIDTH, CUBE_WIDTH,          0., 0., 0.,
	 CUBE_WIDTH,-CUBE_WIDTH, CUBE_HEIGHT, 1., 1.,
	 CUBE_WIDTH, CUBE_WIDTH, CUBE_HEIGHT, 0., 1.,
	} ;
float cube_left[] = {
	1.,
	4.,
	-CUBE_WIDTH,-CUBE_WIDTH,          0., 0., 0.,
	-CUBE_WIDTH,-CUBE_WIDTH, CUBE_HEIGHT, 0., 1.,
	-CUBE_WIDTH, CUBE_WIDTH,          0., 1., 0.,
	-CUBE_WIDTH, CUBE_WIDTH, CUBE_HEIGHT, 1., 1.,
	} ;
float cube_back[] = {
	1.,
	4.,
	-CUBE_WIDTH,-CUBE_WIDTH,          0., 0., 0.,
	 CUBE_WIDTH,-CUBE_WIDTH,          0., 1., 0.,
	-CUBE_WIDTH,-CUBE_WIDTH, CUBE_HEIGHT, 0., 1.,
	 CUBE_WIDTH,-CUBE_WIDTH, CUBE_HEIGHT, 1., 1.,
	} ;

float pyrm_front[] = {
	1.,
	3.,
	 PYRM_WIDTH, PYRM_WIDTH,          0., 0., 0.,
	-PYRM_WIDTH, PYRM_WIDTH,          0., 1., 0.,
	 0.,         0., 		 PYRM_HEIGHT, .5, 1.,
	} ;
float pyrm_right[] = {
	1.,
	3.,
	 PYRM_WIDTH,-PYRM_WIDTH,          0., 1., 0.,
	 PYRM_WIDTH, PYRM_WIDTH,          0., 0., 0.,
	 0.,         0.,		 PYRM_HEIGHT, .5, 1.,
	} ;
float pyrm_left[] = {
	1.,
	3.,
	-PYRM_WIDTH, PYRM_WIDTH,          0., 1., 0.,
	-PYRM_WIDTH,-PYRM_WIDTH,          0., 0., 0.,
	 0.,         0.,		 PYRM_HEIGHT, .5, 1.,
	} ;
float pyrm_back[] = {
	1.,
	3.,
	-PYRM_WIDTH,-PYRM_WIDTH,          0., 0., 0.,
	 PYRM_WIDTH,-PYRM_WIDTH,          0., 1., 0.,
	 0.,         0.,		 PYRM_HEIGHT, .5, 1.,
	} ;

#endif /* !defined(OBSTACLES_H) */
