/*
 * Copyright 1992-1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
#include <math.h>
#include <stdio.h>

static int c(int n, int k);


static int c(int n, int k)
{
	switch(n)
	{
		case 2:
			switch(k)
			{
				case 0: return 1;
				case 1: return 2;
				case 2: return 1;
			}
	
		default: fprintf(stderr,"c: unknown n = %d, k = %d\n",n,k);
	}
}


// returns bspline basis
// n is degree (cubic is 3, quadratic 2)
// k is index of control pt 0 thru degree
// u is 0.0-1.0
float bsbasis(int n, int k, float u)
{
	return c(n,k)*powf(u,(float)k)*powf(1.0-u,(float)(n-k));
}
