/*
 * Copyright 1992-1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
//////////////////////////////////////////////////////////////////////
// Cockpit.h - definition of the render class
//////////////////////////////////////////////////////////////////////

#ifndef RENDER_H
#define RENDER_H

#include "Defines.h"
#include <fmclient.h>
#include <gl/sphere.h>
extern "C" {
#include "shapes.h"
}

// display modes
#define RENDER_WIREFRAME 0
#define RENDER_FILLED 1

// colors used in the overlay planes
#define CLEAR 0
#define GREY1 1
#define GREY2 2
#define GREY3 3

// materials
#define GREY_PLASTIC 1
#define BLACK_PLASTIC 2
#define RED_METAL 3
#define CHARCOAL 4
#define CHROME 5
#define ASPHALT 6
#define YELLOW_ASPHALT 7
#define GREY_RUBBER 8
#define WOOD 9
#define LEAVES 10
#define GREY_METAL 11

// lights
#define DOME_LIGHT 1
#define SUN 2

// cpack colors
#define ORANGE 0x007FFF
#define LIGHT_GREY 0x101010
#define MED_GREY 0x7F7F7F
#define DARK_GREY 0x9F9F9F
#define DASH_GREY 0x303030
#define MED_RED 0x7F
#define ASPHALT_COL 0x0C0C0C
#define YELLOW_ASPHALT_COL 0x00CCCC
#define GRASS_COL 0x209F20
#define SKY_COL 0xFFA000
#define FOG_COL 0x7F7F7F

// patterns
#define HOLES 1

void init_render();
void init_colormaps();

// sweeps the segment defined by r-s counter-clockwise by angle
void sweep(float r[2], float s[2], float angle);

// does a v2f
void vertex(float a, float b);

#endif
