/*
 * Copyright 1992-1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
//////////////////////////////////////////////////////////////////////
// Straight.h - definition of the straight class
//
// This class defines a straightaway stretch of road. It is
// derived from the stretch abstract base class.
//////////////////////////////////////////////////////////////////////

#ifndef STRAIGHT_H
#define STRAIGHT_H

#include "Defines.h"

class Stretch;

class Straight : public Stretch {

public:

	Straight(Stretch *prev, Stretch *next, 
		float length, float width, float hill_angle, 
		float bank_angle = 0.0, float loop_offset = 0.0);
		
	~Straight();
	
protected:

	void make_straight(SbVec3f,SbRotation,float);

};

#endif
	
