/*
 * Copyright 1991, 1992, 1993, 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*
 * Copyright (C) 1991, Silicon Graphics, Inc.
 * All Rights Reserved.
 */

	/*
	 *  globj.h  -  Arbitrary object definitions for the GL
	 *
	 *  Jim Bennett
	 *  1991
	 */

#define	CASE_OBJ	1		/* Keyboard case		*/
#define	KEYL		2		/* White keys:			*/
#define	KEYR		3		/* with black keys on left,	*/
#define	KEYB		4		/* right, both, or neither side	*/
#define	KEYN		5
#define	BLKEY		6		/* Black key			*/
#define	OCTAVE		7		/* An octave of keys		*/
#define	ALL_KEYS	8		/* All keys on the keyboard	*/

				/* Define tops of keys, for hilighting	*/
#define	KEYL_TOP	9		/* White keys:			*/
#define	KEYR_TOP	10		/* with black keys on left,	*/
#define	KEYB_TOP	11		/* right, both, or neither side	*/
#define	KEYN_TOP	12
#define	BLKEY_TOP	13		/* Black key			*/

#define	VSLIDER		14		/* Volume slider		*/
#define	VPEG		15		/* Peg for volume slider	*/

#define	BPATCH		16		/* Button background patch	*/
#define	SEL_BUTTON	17		/* Normal selection button	*/
#define	DOWN_BUTTON	18		/* Depressed (selected) button	*/

#define	NUM_BUTTONS	16		/* ID's 17 - 32 for buttons	*/

#define	KEYNAMES	100		/* Base for individual key names */

	/*
	 *  RGB color definitions
	 */

#define	BACKGROUND	200,255,255

#define	CASE_TOP	64,64,85
#define	CASE_FRONT	16,16,36
#define	CASE_SIDE	0,0,0

#define	WHITE_KEY_TOP	255,240,215
#define	WHITE_KEY_SIDE	200,192,160

#define	BLACK_KEY_TOP	32,32,40
#define	BLACK_KEY_SIDE	0,0,0

#define	HILIGHT		128,96,64

/* Overall dimensions of case	*/

#define	CASE_W		36.0
#define	CASE_D		15.0
#define	FRONT_H		 2.0
#define	BACK_H		 4.0

/* Dimensions of inset in keyboard case (for keys)	*/

#define	INSET_W		30.0
#define	INSET_D		 7.0
#define	INSET_H		 1.0
#define	BLACK_KEY_H	 (0.5+INSET_H)

#define	DEPRESS_H	 0.5

#define	VPEG_H		 0.3
#define	BUTTON_H	 0.5
#define	DOWN_BUTTON_H	 0.2

/* Number of octaves and keys on the keyboard	*/

#define	OCTAVES		5
#define	WHITE_KEYS	((OCTAVES*7)+1)
#define	BLACK_KEYS	(OCTAVES*5)
#define	TOTAL_KEYS	(WHITE_KEYS+BLACK_KEYS)
#define	LAST_KEY	(TOTAL_KEYS-1)

/* Define cursor types	*/

#define	BUSY_BEE_1	1
#define	BUSY_BEE_2	2

/* Define texture and texture environment handles	*/

#define	LOGO_TEX	1
#define	TITLE_TEX	2

#define	DECAL_ENV	1
